package edu.nyu.scps.gesture;

import android.gesture.Gesture;
import android.gesture.GestureLibraries;
import android.gesture.GestureLibrary;
import android.gesture.GestureOverlayView;
import android.gesture.Prediction;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.TextView;
import android.widget.Toast;

import java.util.ArrayList;


public class MainActivity extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        final GestureLibrary library = GestureLibraries.fromRawResource(this, R.raw.gestures);
        if (!library.load()) {
            Toast toast = Toast.makeText(this, "library failed to load", Toast.LENGTH_LONG);
            toast.show();
        }

        final TextView textView = (TextView)findViewById(R.id.textView);
        GestureOverlayView gestures = (GestureOverlayView)findViewById(R.id.gestureOverlayView);

        gestures.addOnGesturePerformedListener(new GestureOverlayView.OnGesturePerformedListener() {

            @Override
            public void onGesturePerformed(GestureOverlayView overlay, Gesture gesture) {
                ArrayList<Prediction> predictions = library.recognize(gesture);

                //If the library recognized the gesture,
                if (predictions.size() > 0 && predictions.get(0).score > 1.0) {
                    textView.setText("");

                    for (int i = 0; i < predictions.size(); ++i) {
                        Prediction p = predictions.get(i);
                        textView.append(i + " " + p.name + " " + p.score + "\n");
                    }
                }
            }
        });
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
}
